; 
    include \masm32\include\masm32rt.inc
; 
.686p

comment * -----------------------------------------------------
                     Build this console app with
                  "MAKEIT.BAT" on the PROJECT menu.
        ----------------------------------------------------- *

    .data?
      value dd ?

    .data
      g_priorityClass textequ <REALTIME_PRIORITY_CLASS>

      ;item dd 0
      g_tallyBucketSize equ 256
      align 16
      REPEAT 2*g_tallyBucketSize
        dd 0
      ENDM
    .code

start:
   
; 
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, g_priorityClass
    invoke GetCurrentThread
    invoke SetThreadPriority, eax, THREAD_PRIORITY_TIME_CRITICAL
    invoke Sleep, 0
    call main
   ; inkey
    exit

; 

main proc
    
    cls
    mov ecx, 10000000
l:
    push ecx
    call timeit
    pop ecx
    dec ecx
    jns l


    ret

main endp

timeit proc
; warmup
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    rdtsc 
    ; now go for real!
    xor eax, eax
    cpuid
    rdtsc
    push eax
    push edx
    
    ;;;;;;;;; code under test should go here!
    xor eax, eax
    cpuid
    rdtsc
    push eax
    push edx
    call print_runtime
    ret

timeit endp

print_runtime proc
    pop esi
    pop edx
    pop eax
    pop ecx
    ;sub edx, ecx
    cmp ecx, edx
    jne wraparound
    pop ecx
    sub eax, ecx
    print ustr$(eax)
    print " ",13,10
    push esi
    ret
wraparound:
    pop ecx
    push esi
    ret
    
print_runtime endp
; 

end start
